Module AccInt;
Exports
imports AccentType from AccentType;
procedure InitAccInt(RPort :port);
Function SetBackLog(
ServPort :port;
LocalPort :port;
BackLog :Integer
):GeneralReturn;
Function AllocatePort(
ServPort :port;
var LocalPort :Port;
BackLog :Integer
):GeneralReturn;
Function DeallocatePort(
ServPort :port;
LocalPort :Port;
Reason :Long
):GeneralReturn;
Function IndexInterpose(
ServPort :port;
MyPort :Port;
HisIndex :Long;
var HisPort :Port
):GeneralReturn;
Function PortInterpose(
ServPort :port;
MyPort :Port;
HisPort :port;
var MyNewPort :Port
):GeneralReturn;
Function Fork(
ServPort :port;
var HisKernelPort :port;
var HisDataPort :port;
var Ports :PtrPortArray;
var Ports_Cnt :long
):GeneralReturn;
Function Status(
ServPort :port;
var NStats :PStatus
):GeneralReturn;
Function Terminate(
ServPort :port;
Reason :Long
):GeneralReturn;
Function SetPriority(
ServPort :port;
Priority :PriorID
):GeneralReturn;
Function SetLimit(
ServPort :port;
ReplyPort :port;
Limit :Long
):GeneralReturn;
Function Suspend(
ServPort :port
):GeneralReturn;
Function Resume(
ServPort :port
):GeneralReturn;
Function Examine(
ServPort :port;
RegOrStack :Boolean;
Index :Integer;
var Value :Integer
):GeneralReturn;
Function Deposit(
ServPort :port;
RegOrStack :Boolean;
Index :Integer;
Value :Integer
):GeneralReturn;
Function SoftInterrupt(
ServPort :port;
NormOrEmerg :Boolean;
var EnOrDisable :Boolean
):GeneralReturn;
Function CreateSegment(
ServPort :port;
ImagSegPort :port;
SegmentKind :SpiceSegKind;
InitialSize :Integer;
MaxSize :Integer;
Stable :Boolean;
var Segment :SegID
):GeneralReturn;
Function TruncateSegment(
ServPort :port;
Segment :SegID;
NewSize :Integer
):GeneralReturn;
Function DestroySegment(
ServPort :port;
Segment :SegID
):GeneralReturn;
Function ReadSegment(
ServPort :port;
Segment :SegID;
Offset :Integer;
NumPages :Integer;
var Data :Pointer;
var Data_Cnt :long
):GeneralReturn;
Function WriteSegment(
ServPort :port;
Segment :SegID;
Offset :Integer;
Data :Pointer;
Data_Cnt :long
):GeneralReturn;
Function ValidateMemory(
ServPort :port;
var Address :VirtualAddress;
NumBytes :Long;
CreateMask :Long
):GeneralReturn;
Function InvalidateMemory(
ServPort :port;
Address :VirtualAddress;
NumBytes :Long
):GeneralReturn;
Function SetProtection(
ServPort :port;
Address :VirtualAddress;
NumBytes :Long;
Protection :Integer
):GeneralReturn;
Function ReadProcessMemory(
ServPort :port;
Address :VirtualAddress;
NumBytes :Long;
var Data :Pointer;
var Data_Cnt :long
):GeneralReturn;
Function WriteProcessMemory(
ServPort :port;
Address :VirtualAddress;
NumBytes :Long;
Data :Pointer;
Data_Cnt :long
):GeneralReturn;
Function GetDiskPartitions(
ServPort :port;
DevNum :Integer;
var DevName :DevPartString;
var PartL :Pointer;
var PartL_Cnt :long
):GeneralReturn;
Function PartMount(
ServPort :port;
PartName :DevPartString;
ExUse :Boolean;
var RootId :SegID;
var PartKind :PartitionType;
var PartPort :port;
var PartS :DiskAddr;
var PartE :DiskAddr
):GeneralReturn;
Function PartDisMount(
ServPort :port
):GeneralReturn;
Function SetTempSegPartition(
ServPort :port;
PartName :DevPartString
):GeneralReturn;
Function SetDebugPort(
ServPort :port;
DebugPort :port
):GeneralReturn;
Function Touch(
ServPort :port;
Address :VirtualAddress
):GeneralReturn;
Function GetPortIndexStatus(
ServPort :port;
PortIndex :Long;
var Backlog :Integer;
var NWaitingMsgs :Integer;
var EWaitingMsgs :Integer;
var PortRight :port;
var PortType :Integer
):GeneralReturn;
Function GetPortStatus(
ServPort :port;
PortRight :port;
var Backlog :Integer;
var NWaitingMsgs :Integer;
var EWaitingMsgs :Integer;
var PortIndex :Long;
var PortType :Integer
):GeneralReturn;
Function ExtractAllRights(
ServPort :port;
PortIndex :Long;
var PortRight :port;
var PortType :Integer
):GeneralReturn;
Function InsertAllRights(
ServPort :port;
PortIndex :Long;
PortRight :port;
PortType :Integer
):GeneralReturn;
Function CreateProcess(
ServPort :port;
var HisKernelPort :port;
var HisDataPort :port
):GeneralReturn;
Function InterceptSegmentCalls(
ServPort :port;
var OldSysPorts :PtrAllPortArray;
var OldSysPorts_Cnt :long;
var SysPorts :PtrPortArray;
var SysPorts_Cnt :long
):GeneralReturn;
Function DirectIO(
ServPort :port;
var CmdBlk :Pointer;
var CmdBlk_Cnt :long;
var DataHdr :Pointer;
var DataHdr_Cnt :long;
var Data :Pointer;
var Data_Cnt :long
):GeneralReturn;
Function SetPagingSegment(
ServPort :port;
Segment :SegID
):GeneralReturn;
Function CreateRectangle(
ServPort :port;
RectPort :port;
BaseAddr :VirtualAddress;
ScanWidth :Integer;
BaseX :Integer;
BaseY :Integer;
MaxX :Integer;
MaxY :Integer;
IsFont :Boolean
):GeneralReturn;
Function DestroyRectangle(
ServPort :port;
RectPort :port
):GeneralReturn;
Function AvailableVM(
ServPort :port;
var NumBytes :Long
):GeneralReturn;
Function EnableRectangles(
ServPort :port;
RectList :PtrPortArray;
RectList_Cnt :long;
Enable :Boolean
):GeneralReturn;
Function SetKernelWindow(
ServPort :port;
LeftX :Integer;
TopY :Integer;
Width :Integer;
Height :Integer;
Inverted :Boolean
):GeneralReturn;
Private
 { Stub created by MakeStub at15-Feb-84  17:22:25 }
begin
end.
