Module MultiRead;
{-----------------------------------------------------------------------------
   MultiRead - Module to Multi-sector read a file into memory.

   Written by Brad Myers    24 Jul 81.

   Copyright (C) Three Rivers Computer Corporation, 1981.

 Abstract:
       This Module exports a procedure to read a file very quickly into
       memory.  The memory for the blocks of the file to be read must be
       allocated contiguously before the call is made.  Typically, this
       will be done by using CreateSegment.

-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------
  Change Log:
     24-Jul-81  V1.0  Brad Myers
               Created by modifying code in the Loader
-----------------------------------------------------------------------------}

{//////////////////////////} EXPORTS {\\\\\\\\\\\\\\\\\\\\\\\\\\}

Imports FileSystem from FileSystem;

Procedure MultiRead(fid: FileID; addr: pDirBlk; firstBlock,numBlocks: integer);

{//////////////////////////} PRIVATE {\\\\\\\\\\\\\\\\\\\\\\\\\\}
