Module Scrounge;

{-----------------------------------------------------------------------------
 Title: PERQ Pascal Preliminary debugger.
 Abstract: This module contains the procedure Scrounge which allows a small
            amount of debugging.  Since there are no symbol tables or micro--
            code support for breakpoints, you can look at the stack trace and
            examine vbles by offsets.  The types of the variables have to be
            specified by the user.
 Written by: Brad A. Myers  1-May-1981
 Copyright (C) 1981 Three Rivers Computer Corporation.
 
-----------------------------------------------------------------------------}

{----------------------------------------------------------------------------
  Versions:
    
    11 Dec 81  V0.14  WJHansen       Change to set InCmdFile False instead
                                         of closing CmdFile
                      Brad A. Myers  enable keyboard at start of Scrounge
                      
     3 Dec-81  V0.13  Brad Myers     ChangeWindow(0).
                                     Help exception.
                                     Command for showing exception parameters.
                                     Command to dereference pointers.
    26-Oct-81  V0.12  John P. Strait Change to agree with V2.11 Memory.
    30-Jun-81  V0.11  Brad A. Myers  Increase screen size for default window
                                     Set ^S Pending to false
                                     Fix ^Shift-D while ^Shift-D
                                     Remove n command (NIY anyway)
     5-Jun-81  V0.10  Brad A. Myers  Fixed ^C handling
                                     More information when Scrounge aborts
     4-Jun-81  V0.9   Brad A. Myers  Catch FSNotFnd for lookups
                                     Clear IO buffer for CleanUp.
     1-Jun-81  V0.8   Brad A. Myers  Fixed bugs in recursive invocation.
    28-May-81  V0.7   Brad A. Myers  Made safer for recursive invocation.
                                     Add all handlers
    23-May-81  V0.6   John P. Strait Enable keyboard interrupts before reading.
    22-May-81  V0.5   John P. Strait Change call to StreamKeyBoardReset.
    20-May-81  V0.4   Brad A. Myers  New stream reset procedure
                                      Compiler switch for run info at top
                                      Proceed command
    12-May-81  V0.3   Brad A. Myers  Use new IO modules; new exceptions
     6-May-81  V0.2   Brad A. Myers  No procedure names for system modules
                                       until debug since takes too long
     1-May-81  V0.1   Brad A. Myers  Started by reworking PMD
-----------------------------------------------------------------------------}


{////////////////////////} EXPORTS {\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}

Procedure Scrounge(ES, ER, PStart, PEnd, ExcSeg, RaiseAP: Integer);

{////////////////////////} PRIVATE {\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}
